//West Islip High School - Engineering Technology
// Motor Test Sketch for H-Bridge and two DC Motors

// defines pins numbers
int E1 = 5;  // Enable Pin for motor 1 (ENA on board)
int E2 = 6;  // Enable Pin for motor 2 (ENB on board)

int I1 = 2;  // Control pin 1 for motor 1
int I2 = 3;  // Control pin 2 for motor 1
int I3 = 4;  // Control pin 1 for motor 2
int I4 = 7;  // Control pin 2 for motor 2
 
//pins for echo
const int trigPin = 9;
const int echoPin = 10;
const int buzzer = 11;
const int ledPin = 13;

// defines variables for echo
long duration;
int distance;
int safetyDistance;

void setup() {
 

//Set-Up for Motor Pins
  pinMode(E1, OUTPUT);    //Control pin for Motor 1 set to OUTPUT
  pinMode(E2, OUTPUT);    //Control pin for Motor 2 set to OUTPUT

  pinMode(I1, OUTPUT);    //Voltage direction pin for Motor 1 set to OUTPUT    
  pinMode(I2, OUTPUT);    //Voltage direction pin for Motor 1 set to OUTPUT
  
  pinMode(I3, OUTPUT);    //Voltage direction pin for Motor 2 set to OUTPUT
  pinMode(I4, OUTPUT);    //Voltage direction pin for Motor 2 set to OUTPUT

//setup echo pins
pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
pinMode(echoPin, INPUT); // Sets the echoPin as an Input
pinMode(buzzer, OUTPUT);
pinMode(ledPin, OUTPUT);
Serial.begin(9600); // Starts the serial communication

}


void loop() {
    
    //setsup motors
    analogWrite(E1, 250);  // Motor 1 get ready - high speed
  analogWrite(E2, 250); // Motor 2 get ready - high speed
  
 // Clears the trigPin
digitalWrite(trigPin, LOW);
delayMicroseconds(2);

// Sets the trigPin on HIGH state for 10 micro seconds
digitalWrite(trigPin, HIGH);
delayMicroseconds(10);
digitalWrite(trigPin, LOW);

// Reads the echoPin, returns the sound wave travel time in microseconds
duration = pulseIn(echoPin, HIGH);

// Calculating the distance
distance= duration*0.034/2;

safetyDistance = distance;

if (safetyDistance <= 15){
  digitalWrite(buzzer, HIGH);
  digitalWrite(ledPin, HIGH);
  // Turn off one motor- backup with the other
    digitalWrite(I1, LOW);  //Motor 1 - polarity -
    digitalWrite(I2, LOW); //Motor 1 - polarity +
    
    digitalWrite(I3, LOW); //Motor 2 - polarity -
    digitalWrite(I4, HIGH); //Motor 2 - polarity +

   //delay(500);
}
else{
  digitalWrite(buzzer, LOW);
  digitalWrite(ledPin, LOW);
  // go forward - both wheels rotate same direction

    digitalWrite(I1, HIGH); //Motor 1 - polarity +
    digitalWrite(I2, LOW);  //Motor 1 - polarity -
    
    digitalWrite(I3, HIGH); //Motor 2 - polarity +
    digitalWrite(I4, LOW); //Motor 2 - polarity -

    //delay(500);
}

// Prints the distance on the Serial Monitor
Serial.print("Distance: ");
Serial.println(distance);

  

    
// turn 90 degrees - both wheels rotate oposite directions
    //digitalWrite(I1, LOW); //Motor 1 - polarity -
    //digitalWrite(I2, HIGH); //Motor 1 - polarity +
    
    //digitalWrite(I3, HIGH); //Motor 2 - polarity +
    //digitalWrite(I4, LOW); //Motor 2 - polarity -

  //delay(2000);
  

    
// Stop Wheels

    //digitalWrite(I1, LOW); //Motor 1 - polarity -
    //digitalWrite(I2, LOW); //Motor 1 - polarity -
    
    //digitalWrite(I3, LOW); //Motor 2 - polarity -
    //digitalWrite(I4, LOW);  //Motor 2 - polarity -

    //delay(2000);

}
